fk_dasy_map <- function(df, attr_col, census_sp) {
  out=rep(NA,nrow(census_sp))
  #wybrac z blokow komorki ktore nie maja na
  na_selector=!is.na(census_sp@data$cns_id)
  #create tmp layer 
  tmp_data=census_sp@data[na_selector,]
  
  for(class in ancillary_class) {
    selector=tmp_data$ancillary==class
    tmp_data$out[selector]=df[tmp_data$cns_id[selector],class+attr_col]
    
  }
  out[na_selector]=tmp_data$out
  return(out)
}


fk_dasy=function(density_coefficients,input_df)
{
    coefs=density_coefficients
    pop=input_df$pop
    areas=input_df[,-c(1,2,ncol(input_df)-1,ncol(input_df))]
    cns_id=input_df[,ncol(input_df)]
    cns_units=input_df$cns
    
    #calc weights denominator
    w=mapply(`*`,areas,coefs)
    w=data.frame(w)
    w$wd=apply(w, 1,sum)

    weights=data.frame(matrix(ncol=length(coefs), nrow=nrow(w)))
    for (i in 1:length(coefs)) {
      weights[i]=coefs[i]/w$wd
    }
    
    predicted_pop=weights*pop
    dasy_df=data.frame(cns_id=cns_id,cns_units=cns_units,weights,predicted_pop)
    colnames(dasy_df) = c("cns_id", "cns_units", paste("w", ancillary_class, sep=""), paste("p", ancillary_class, sep=""))
    return=dasy_df
}


fk_dasy_weights=function(density_coefficients,input_df)
{
  
  coefs=density_coefficients
  areas=input_df[,-c(1,2,3,4,5,ncol(input_df))]
  cns_id=input_df$cns_id
  #cns_units=input_df$cns_units
  
  #calc weights denominator
  w=mapply(`*`,areas,coefs)
  w=data.frame(w)
  w$wd=apply(w, 1,sum)
  
  weights=data.frame(matrix(ncol=length(coefs), nrow=nrow(w)))
  for (i in 1:length(coefs)) {
    weights[i]=coefs[i]/w$wd
    weights[areas[i]==0,i]=0 #jak area jest =0 to zamien wage na 0 
  }
  
  weights[is.na(weights) | weights==Inf]=0
  weights_df=data.frame(cns_id=cns_id, GISJOIN=input_df$GISJOIN, state_code=input_df$STATE_CODE, county_code=input_df$COUNTY_CODE, weights)
  
  colnames(weights_df) = c("cns_id", "GISJOIN", "state_code", "county_code", paste("w", ancillary_class, sep=""))
  
  return=weights_df
}

