#!/usr/bin/env Rscript 
#This script export data for each county from spatial data frame into GeoTiff. In next step county-based dasymetric map are join into one map for the entire U.S

library(rgdal)

source("dasy_parameters.R")
source("list_of_states.R")


pf=getwd()
# Start the clock!
ptm_all <- proc.time()


dir.create(file.path(pf, out_tif_pf, fsep = .Platform$file.sep), showWarnings = FALSE, recursive = TRUE)

for (state in list_of_states$ABBR)
{
  print(state)
  #extract county name. File name is i.e. cnt_39001, county should be only 39001
  list_files = list.files(file.path(out_path, state, fsep = .Platform$file.sep), pattern = ".rds")
  x <- lapply(list_files,FUN=function(x) unlist(strsplit(x,'[_ .]')))
  y=as.data.frame(x)
  z=t(y)
  rownames(z)<-NULL
  list_of_counties = z[,2]
  print(list_of_counties)

  #Calculate for each county - export pop to geotiff
  for (county in list_of_counties)
  {
    print(county)
    census_sp = readRDS(file.path(out_path, state, paste("cnt_", county, ".rds", sep=""), fsep = .Platform$file.sep))
    
    ###SAVE POPULATION 
    writeGDAL(census_sp["pop"], file.path(out_tif_pf, paste("cnt_", county, out_tif_map_name, ".tif", sep="" ), fsep = .Platform$file.sep), mvFlag = "-9999")
  }  

}

# Stop the clock
proc.time() - ptm_all

